package de.itdesign.meisterplan.shared.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class OBSUnitModelData extends BaseModelData implements OBSUnitModel {
    private static final long serialVersionUID = 6479128307830556475L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer internalId;

    private OBSUnitModel parent = null;

    @OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, orphanRemoval = true)
    private Set<OBSUnitModel> children;
    @Column(nullable = false)
    private String code;
    private String name;

    public OBSUnitModelData() {
        children = new HashSet<OBSUnitModel>();
    }

    @Override
    public OBSUnitModel getParent() {
        return parent;
    }

    @Override
    public Set<OBSUnitModel> getChildren() {
        return children;
    }

    @Override
    public Integer getId() {
        return internalId;
    }
}
